import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { TrendLineType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { Axis } from "./Axis";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { ScatterFrame } from "./ScatterFrame";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Rect } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { AxisRange } from "./AxisRange";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { IErrorBarCalculator } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class ScatterBase extends MarkerSeries implements ISupportsErrorBars, ITrendLineSeries {
    static $t: Type;
    protected bf(): SeriesView;
    ht(): void;
    iu(a: SeriesView): void;
    m5: ScatterBaseView;
    protected get_c4(): boolean;
    ag(): Axis[];
    fs(a: any, b: string): any;
    ch(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    protected bd(): SeriesHitTestMode;
    lw(a: Point): Rect;
    dh(a: Point, b: boolean): boolean;
    constructor();
    m4: ScatterAxisInfoCache;
    xAxis: NumericXAxis;
    yAxis: NumericYAxis;
    nr: string;
    nd: IFastItemColumn$1<number>;
    private nc;
    nv: string;
    nf: IFastItemColumn$1<number>;
    private ne;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    os: Brush;
    static readonly od: DependencyProperty;
    trendLineThickness: number;
    ou: PenLineCap;
    ot: DoubleCollection;
    trendLinePeriod: number;
    m1: CollisionAvoidanceType;
    readonly GetErrorBarsXAxis: Axis;
    readonly GetErrorBarsYAxis: Axis;
    nl: number;
    nk: number;
    ib(): void;
    m6: ScatterErrorBarSettings;
    protected iz(a: any, b: string, c: any, d: any): void;
    nh(a: any): boolean;
    ng(a: any): boolean;
    private oc;
    private ov;
    private ow;
    private nx;
    protected ni(a: string, b: FastItemsSourceEventAction): boolean;
    protected hy(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    n5(a: ScatterFrame): void;
    n6(a: ScatterFrame, b: Clipper): void;
    an(a: Axis): AxisRange;
    fp(a: Point): any;
    e8(a: Point): number;
    c9(a: any): boolean;
    protected js(a: Rect, b: Rect): void;
    protected jt(a: Rect, b: Rect): void;
    m9: ScatterFrame;
    nb: ScatterFrame;
    m8: ScatterFrame;
    ny(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    n2(a: ScatterFrame, b: ScatterBaseView): void;
    hv(a: boolean, b: SeriesView): void;
    ob(a: ScatterFrame, b: ScatterBaseView): void;
    n0(a: ScatterFrame, b: ScatterBaseView): void;
    n3(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    n1(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    nz(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: any, e: number, f: number, g: boolean): {
        p4?: number;
        p5?: number;
    };
    n4(a: ErrorBarsHelper, b: IErrorBarCalculator, c: number, d: number, e: number, f: boolean): {
        p2?: number;
        p3?: number;
        p4?: number;
    };
    n8(a: ScatterFrame, b: ScatterBaseView): void;
    private n9;
    private oa;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    je(a: boolean): void;
    protected jo(): void;
    na: ScatterFrame;
    jf(a: Rect, b: RenderSurface): void;
    private m7;
    jc(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    n7(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    m0(a: ScatterBaseView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    nj(a: HashPool$2<any, Marker>, b: List$1<number>): List$1<number>;
    protected h4(a: any): void;
    eh(): number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterBaseView extends MarkerSeriesView {
    static $t: Type;
    cr: MarkerManagerBase;
    protected cp: Point[];
    protected cs: ScatterBase;
    protected cx: List$1<number>;
    constructor(a: ScatterBase);
    private c7;
    private c8;
    ct: ScatterTrendLineManager;
    ap(): void;
    private c6;
    c9(a: Marker): Size;
    protected cq(): MarkerManagerBase;
    protected c4(a: IDictionary$2<any, OwnedPoint>): void;
    cw(): List$1<Marker>;
    co(): Point[];
    protected cn(): Point[];
    protected cv(): List$1<number>;
    cy(): void;
    c2(a: PathGeometry): void;
    cz(): void;
    c3(a: PathGeometry): void;
    c5(): void;
    cu: HashPool$2<any, Marker>;
    cc(a: (arg1: Marker) => void): void;
    c1(): void;
    protected a2(a: RenderingContext, b: boolean): void;
    c0(a: boolean): void;
    getDefaultTooltipTemplate(): string;
}
